#version 150

#moj_import <fog.glsl>

in vec3 Position;
in vec4 Color;
in vec2 UV0;
in ivec2 UV2;

uniform sampler2D Sampler2;

uniform mat4 ModelViewMat;
uniform mat4 ProjMat;
uniform int FogShape;
uniform vec2 ScreenSize;

out float vertexDistance;
out vec4 vertexColor;
out vec2 texCoord0;

void main() {
    gl_Position = ProjMat * ModelViewMat * vec4(Position, 1.0);
    vertexDistance = fog_distance(Position, FogShape);
    vertexColor = Color * texelFetch(Sampler2, UV2 / 16, 0);
    texCoord0 = UV0;

    float guiScale = (round(ScreenSize.x * ProjMat[0][0] / 2));
    // Move bossbars
    if (Position.z == 1000 || Position.z == 1000.03) {
        if (gl_Position.y > 1.0 - 30/ScreenSize.y*guiScale) {
            gl_Position.y += -2.0 + 100/ScreenSize.y*guiScale;
        } else {
            gl_Position = ProjMat * ModelViewMat * (vec4(Position, 1.0) - vec4(0,34,0,0));
        }
       
    }
    // Move actionbar
    if (Position.z == 2200 || Position.z == 2200.03) {
        gl_Position = ProjMat * ModelViewMat * (vec4(Position, 1.0) + vec4(0,10,0,0));
    }
    // Move Chat .0 .01 .03 .04
    if (Position.z >= 2650 && Position.z <= 2650.04 ) {
        gl_Position = ProjMat * ModelViewMat * (vec4(Position, 1.0) - vec4(0,30,0,0));
    }
    //  ?                     XP level             Item count
    if (Position.z == 2400 || Position.z == 600 || Position.z == 300 || Position.z == 300.03 || Position.z == 432 || Position.z == 432.03) {
        vertexColor = vec4(0,0,0,0);
    }
}